!=======================================================================
      subroutine diagonal(n     ,c_ind , r_point,           &
                         ilu   ,ilup  ,  iwork , space  ,   &
                         ierr  , mneed )

      implicit none
!-----------------------------------------------------------------------
!   n, c_ind, r_point: structure of matrix A
!   ilu, ilup: pointers to the structure array of ECIMGS pattern
!   iwork, space: work space woth size = size_work
!   ierr: error code
!       = 0, no error is detected
!c      = 1, short of space
!-----------------------------------------------------------------------
    integer n, c_ind(*), r_point(*), iwork(*)
    integer ilu, ilup, space, ierr, mneed
    integer i
    
    if (space .lt. 2*n+2) then
        ierr = 1
        mneed = 2*n+2 - space
        goto 1000
    endif
!
!  compute the pattern: 
!   
    ilup = 1
    ilu = n+1
    iwork(ilu) = n+2
    do i = 1, n
        iwork(ilup+i-1) = n+2
        iwork(ilu+i)  = n+2
    enddo
1000    continue
    return
    end
    
